%% brute.m
%% December 5th, 2005
%%
%% Scan the whole function
%% -a: image a
%% -b: image b
%% -measure: measure function between a and b
%% -X: range of possible x
%% -Y: range of possible y
%% -T: raneg of possible thetas
%% -f: 3d function containing the value of measure
%% -fxyz: index in f of the maximum value
%%
%% plot f using:
%%   [x y] = meshgrid(X,Y);
%%   surf(x,y,mi(:,:,t)); %with t fixed

function [f fx fy ft] = brute(a,b,measure,X,Y,T)

  % Scan the whole domain
  fx=1; fy=1; ft=1; maxmi=0; % index of maximum
  cntX=1;
  for x=X
    cntY = 1;
    for y=Y
      cntT = 1;
      for t=T
        f(cntX,cntY,cntT) = measure(a,transformation(b,x,y,t));
        if f(cntX,cntY,cntT) > maxmi
          fx=cntX;fy=cntY;ft=cntT;maxmi=f(cntX,cntY,cntT);
        end;
        cntT=cntT+1;
        [x y t] %display
      end;
      cntY=cntY+1;
    end;
    cntX=cntX+1;
  end;
  
end
