%% combine.m
%% December 5th, 2005
%%
%% Combine 2 pictures, so we can compare the registration result

function c = combine(a,b)

  rows = size(a,1);
  cols = size(a,2);

  [gax gay] = gradient(im2double(a));
  [gbx gby] = gradient(im2double(b));
  ga = uint8(((gax.*gax + gay.*gay)>0.01)*255);
  gb = uint8(((gbx.*gbx + gby.*gby)>0.01)*255);

  s = 100; % size of each small square
  c = (checkerboard(s,rows/s,cols/s)>0);
  maska = uint8(c(1:rows,1:cols));
  maskb = uint8(~maska);
  clear c;

  c = zeros(size(a,1),size(a,2),3,'uint8');
  c(:,:,1) = 0.0*(maska.*a + maskb.*b) + ga;
  c(:,:,2) = 0.0*(maska.*a + maskb.*b) + gb;
  c(:,:,3) = 0.0*(maska.*a + maskb.*b);

  max(c(:))

end
