%% entropy.m
%% Herve Lombaert, December 2th, 2005
%%
%% Compute the Shannon entropy of an image
%% -image:   grey image

function h = entropy(image)

    % Probabilities p[i] of a pixel having intensity [i]
    p = histc(image(:), 0:255);
    p = p / sum(p);
    
    % Entropy
    h = - p' * log(p + ~(p|0)); % correction 0*log(0)=0
    
end
