%% gradientenergy.m
%% Herve Lombaert, December 4th, 2005
%%
%% Compute the gradient energy (penalize different gradient orientation)
%% -a: image a
%% -b: image b
%% The two images must have the same size

function g = gradientenergy(a, b)

  if size(a) ~= size(b), disp('a,b must have the same size'); end;

  [ax ay] = gradient(im2double(a));
  [bx by] = gradient(im2double(b));
  norma = sqrt(ax.*ax+ay.*ay);
  normb = sqrt(bx.*bx+by.*by);
  normab = norma .* normb;

  cosa = (ax.*bx + ay.*by)./(normab + ~(normab|0));
  angle = acos(cosa);
  angle = real(angle); % angles should not be complex
  w = (cos(2*angle)+1)/2;
  wn = w .* min(norma,normb);

  g = sum(wn(:));

end
