%% mutualinformation.m
%% Herve Lombaert, December 2th, 2005
%%
%% Compute the mutual information between two images
%% -a: image a
%% -b: image b
%% The two images must have the same size

function mi = information_mutuelle(a, b)

    if size(a) ~= size(b), disp('a,b must have the same size'); end;

    ha = entropy(a);
    hb = entropy(b);
    pab = jointhistogram(a,b);
    hab = - pab(:)' * log(pab(:) + ~(pab(:)|0));
    
    mi = (ha + hb) - hab;

end

