%% jointhistogram.m
%% Herve Lombaert, December 2th, 2005
%%
%% Compute the joint histogram of 2 images
%% -a: image A
%% -b: image B
%% The two images must have the same size

function pab = jointhistogram(a, b)

    if size(a) ~= size(b), disp('a,b must have the same size'); end;

    pair = [a(:) b(:)];
    pab = zeros(256,256);
    for i=1:size(pair,1)
        ia = pair(i,1)+1;
        ib = pair(i,2)+1;
        pab(ia,ib) = pab(ia,ib) + 1;
    end
    pab = pab / sum(pab(:));

end
