%% recalage.m
%% Herve Lombaert
%% Jeremie Theriault
%%
%% Script lancant un recalage

clear all;
 
 
%% test recalage intra modal
%  image1 = imread('brainMR.pgm');
%  imaget = imread('brainMRMix.pgm');
%  template = zeros(size(image1), 'uint8');
%  template(1:size(imaget,1),1:size(imaget,2)) = imaget;
%  clear imaget;

%% test recalage multimodal
   image1 = imread('images/CT.pgm');
   template = transformation(imread('images/MR.pgm'), -5, 4, -25);
   %template = imread('MR.pgm');

% Choix de la mthode de recalage
% Calcul_Coef = @correlation;
% Calcul_Coef = @correlation_norm;
% Calcul_Coef = @information_mutuelle;
% Calcul_Coef = @information_mutuelle_normalisee;
 Calcul_Coef = @gradient_information_mutuelle;
% Calcul_Coef = @gradient_information_mutuelle_normalisee;

 
% On lance la recherche des parametres du recalage
[x, y, t] = simpowell(Calcul_Coef, image1, template, 0, 0, 0);

% Affichage des images recalees
image2 = transformation(template, x,y,t);
dx = -5 + x;
dy = 0 + y;
dt = -25 + t;

clf;

a = zeros(size(image1,1),size(image1,2),3);
b = zeros(size(image1,1),size(image1,2),3);

a(:,:,1) = 0.5*modgradient(image1);
a(:,:,2) = modgradient(template);

b(:,:,1) = 0.5*modgradient(image1);
b(:,:,2) = modgradient(image2);

%imshow((0.5*image1+0.5*image2));
subplot(2,2,1); imshow(image1); title('(a) CT scan');
subplot(2,2,2); imshow(template); title('(b) MR scan');
subplot(2,2,3); imshow(a); title('(c) Avant recalage');
subplot(2,2,4); imshow(b); title(['(d) dx=' num2str(x) ', dy=' num2str(y) ', d\theta=' num2str(t)]);
