%% testcameraman.m
%%
%% Trace une surface fonction des differentes emsures de similarites
%% filename: fichier a recaler avec lui meme (images/cameraman.png)
%% n: numero du test:
%%	1 information du gradient avec information mutuelle normalisee
%%	2 information du gradient avec information mutuelle
%%	3 information mutuelle normalisee
%%	4 information mutuelle
%%	5 correlation normalisee
%%	6 correlation

function testcameraman(filename,n)

	switch n
	case 1
		func = @gradient_information_mutuelle_normalisee;
	case 2
		func = @gradient_information_mutuelle;
	case 3
		func = @information_mutuelle_normalisee;
	case 4
		func = @information_mutuelle;
	case 5
		func = @correlation_norm;
	case 6
		func = @correlation;
	end

	tx = 4;
	ty = 8;
	R=-20:20;
	X = R-tx;
	Y = R-ty;

	% Load image
	a = imread(filename);
	b = transformation(a,4,8,0);
	b = imnoise(b,'gaussian',0,0.01);

	[x y] = meshgrid(Y, X);

	% Scan the function
	[f fx fy ft] = brute(a,b,func,X,Y,0);

	% Display
	surf(y,x,f(:,:,1));
	hold on; plot3(X(fx),Y(fy),f(fx,fy),'o');
	title(['maximum a (' num2str(X(fx)) ',' num2str(Y(fy)) ')']);
	xlabel('X translation');
	ylabel('Y translation');

	switch n
	case 1
		zlabel('gnmi');
		print -dbmp256 'test-cameraman-gnmi.bmp';
		save 'test-cameraman-gnmi.mat' a b f fx fy ft x y;
	case 2
		zlabel('gmi');
		print -dbmp256 'test-cameraman-gmi.bmp';
		save 'test-cameraman-gmi.mat' a b f fx fy ft x y;
	case 3
		zlabel('nmi');
		print -dbmp256 'test-cameraman-nmi.bmp';
		save 'test-cameraman-nmi.mat' a b f fx fy ft x y;
	case 4
		zlabel('mi');
		print -dbmp256 'test-cameraman-mi.bmp';
		save 'test-cameraman-mi.mat' a b f fx fy ft x y;
	case 5
		zlabel('ncorr');
		print -dbmp256 'test-cameraman-ncorr.bmp';
		save 'test-cameraman-ncorr.mat' a b f fx fy ft x y;
	case 6
		zlabel('corr');
		print -dbmp256 'test-cameraman-corr.bmp';
		save 'test-cameraman-corr.mat' a b f fx fy ft x y;
	end

end
