%% test.m
%%
%% Trace une courbe, fonction d'une mesure de recalage, en vaisant varier
%% la translation d'une image carre 
%%
%% func: fonction mesurant la mesure de recalage (eg. @information_mutuelle)

function testcarre(func)

	X = -12:12;

	% Carres
	[f1 a1 b1] = measurecarre(1,71,func,X);
	[f2 a2 b2] = measurecarre(10,80,func,X);

	% display
	subplot(2,3,1); imshow(mat2gray(a1,[0 255])); title('reference');
	subplot(2,3,2); imshow(mat2gray(b1,[0 255])); title('template');
	subplot(2,3,3); plot(X,f1); title('mesure du recalage'); xlabel('translation');
	subplot(2,3,4); imshow(mat2gray(a2,[0 255])); title('reference');
	subplot(2,3,5); imshow(mat2gray(b2,[0 255])); title('template');
	subplot(2,3,6); plot(X,f2); title('mesure du recalage'); xlabel('translation');

end

function [f a b] = measurecarre(ext,int,func,X)

	% reference image
	a = ones(19,19)*ext;
	a(6:14,6:14) = ones(9,9)*int;

	% moving image (inverted image)
	b = 255-a;

	% translate
	cnt = 1;
	for x=X
		f(cnt) = func(a,transformation(b,x,0,0));
		cnt = cnt+1;
	end

end
