%% testcrane.m
%%
%% Trace une surface fonction des differentes emsures de similarites
%% filenamea: fichier a recaler (images/CT.pgm)
%% filenameb: fichier a recaler (images/MR.pgm)
%% n: numero du test:
%%	1 information du gradient avec information mutuelle normalisee
%%	2 information du gradient avec information mutuelle
%%	3 information mutuelle normalisee
%%	4 information mutuelle
%%	5 correlation normalisee
%%	6 correlation


function testcrane(filenamea, filenameb, n)

	switch n
	case 1
		func = @gradient_information_mutuelle_normalisee;
	case 2
		func = @gradient_information_mutuelle;
	case 3
		func = @information_mutuelle_normalisee;
	case 4
		func = @information_mutuelle;
	case 5
		func = @correlation_norm;
	case 6
		func = @correlation;
	end

	tx = 0;
	ty = -4;
	R=-20:20;
	X = R-tx;
	Y = R-ty;

	% Load image
	a = imread(filenamea);
	b = imread(filenameb);

	[x y] = meshgrid(Y, X);

	% Scan the function
	[f fx fy ft] = brute(a,b,func,X,Y,0);

	% Display
	surf(y,x,f(:,:,1));
	hold on; plot3(X(fx),Y(fy),f(fx,fy),'o');
	title(['maximum a (' num2str(X(fx)) ',' num2str(Y(fy)) ')']);
	xlabel('X translation');
	ylabel('Y translation');

	switch n
	case 1
		zlabel('gnmi');
		print -dbmp256 'test-crane-gnmi.bmp';
		save 'test-crane-gnmi.mat' a b f fx fy ft x y;
	case 2
		zlabel('gmi');
		print -dbmp256 'test-crane-gmi.bmp';
		save 'test-crane-gmi.mat' a b f fx fy ft x y;
	case 3
		zlabel('nmi');
		print -dbmp256 'test-crane-nmi.bmp';
		save 'test-crane-nmi.mat' a b f fx fy ft x y;
	case 4
		zlabel('mi');
		print -dbmp256 'test-crane-mi.bmp';
		save 'test-crane-mi.mat' a b f fx fy ft x y;
	case 5
		zlabel('ncorr');
		print -dbmp256 'test-crane-ncorr.bmp';
		save 'test-crane-ncorr.mat' a b f fx fy ft x y;
	case 6
		zlabel('corr');
		print -dbmp256 'test-crane-corr.bmp';
		save 'test-crane-corr.mat' a b f fx fy ft x y;
	end

end
