%% testrotation.m
%%
%% Trace une courbe, fonction d'une mesure de recalage, en vaisant varier
%% la rotation de l'image du cameraman
%%
%% func: fonction mesurant la mesure de recalage (eg. @information_mutuelle)


function testrotationcameraman(func)

	T = -45:1:45;

	a = imread('images/cameraman.png');

	b10 = imnoise(a,'gaussian',0,0.01);
	b20 = imnoise(a,'gaussian',0,0.10);

	b1 = transformation(b10,0,0,15);
	b2 = transformation(b20,0,0,15);
	
	f1 = measurerotation(a,b1,func,T);
	f2 = measurerotation(a,b2,func,T);
	
	subplot(2,3,1); imshow(a); title('reference');
	subplot(2,3,2); imshow(b1); title('template (dev: 2)');
	subplot(2,3,3); plot(T,f1); title('mesure du recalage'); xlabel('rotation');
	subplot(2,3,4); imshow(a); title('reference');
	subplot(2,3,5); imshow(b2); title('template (dev: 25)');
	subplot(2,3,6); plot(T,f2); title('mesure du recalage'); xlabel('rotation');

end

function f = measurerotation(a,b,func,T)

	cnt = 1;
	for t=T
		f(cnt) = func(a,transformation(b,0,0,t));
		cnt = cnt+1;
	end

end
