%% testrotation.m
%%
%% Trace une courbe, fonction d'une mesure de recalage, en vaisant varier
%% la rotation de l'image du crane
%%
%% func: fonction mesurant la mesure de recalage (eg. @information_mutuelle)

function testrotationcrane(func)

	T = -45:1:45;

	a = imread('images/CT.pgm');
	b = imread('images/MR.pgm');
	b = transformation(b,0,4,15);
	
	f = measurerotation(a,b,func,T);
	
	clf;
	subplot(1,3,1); imshow(a); title('reference (CT)');
	subplot(1,3,2); imshow(b); title('template (MR)');
	subplot(1,3,3); plot(T,f); title('mesure du recalage'); xlabel('rotation');

end

function f = measurerotation(a,b,func,T)

	cnt = 1;
	for t=T
		f(cnt) = func(a,transformation(b,0,0,t));
		cnt = cnt+1;
	end

end
