%% transformation.m
%% December 5th, 2005
%%
%% Transform an image, given tx, ty, theta
%% -A: image to be transformed
%% -tx: change in vertical axis (positive is pointing down)
%% -ty: change in horizontal axis (positive is pointing right)
%% -theta: in degrees, counterclockwise

function TA = transformation(A, tx, ty, theta)

    t = theta*pi/180;
    T = [1 0 0; 0 1 0; -size(A,2)/2 -size(A,1)/2 1] * ...
        [cos(-t) sin(-t) 0; -sin(-t) cos(-t) 0; tx ty 1] * ...
        [1 0 0; 0 1 0; size(A,2)/2+tx size(A,1)/2+ty 1];
    tform = maketform('affine', T);
    TA = imtransform(A, tform, ...
                     'bicubic', ...
                     'XData', [1 size(A,2)], ...
                     'YData', [1 size(A,1)]);

%                     'nearest', ...
%                     'bilinear', ...
%                     'bicubic', ...

end
